<?php
/*                                                       */
/* initialize.php - Init fr Belegungsplaner             */
/* $ID 008 - 2024-01-12 - brom $                         */
/*                                                       */
/* BROM CMS/BelCal Project  <http://www.brom-belcal.de> */
/*                                                       */
/* BROM CMS/BelCal is software you can redistribute it  */
/* under the terms the BROM CMS/BelCal license for free */
/* and modify scripts but without warranty. It is not    */
/* redistributable for payment.                          */
/*                                                       */
/* A distribution of payment will be provided            */
/* exclusively by BROM Service see website or send mail. */
/*                                                       */
/* (c) by BROM-Service 2008  (kontakt@brom-belcal.de)    */
/*                                                       */

// we set the starttime for process timer
$starttime=array_sum(explode(" ",microtime()));
function get_cryptpw($sourcestring,$cryptkey='',$decrypt=false) {
	if(empty($cryptkey)){ $cryptkey = DB_USERNAME; }
	$result = '';
	if($decrypt==true){ $sourcestring = base64_decode($sourcestring); }
	for($i=0; $i<strlen ($sourcestring); $i++) {
		$char = substr($sourcestring, $i, 1);
		$p = abs(strlen($cryptkey)-(2*$i));
		$p = ($p>strlen($cryptkey)?$p-strlen($cryptkey):$p);
		if($p == 0){ $p=abs(strlen($cryptkey)); }
		$keychar = substr($cryptkey, ($i % $p), 1);
		$char = chr(ord($char)^ord($keychar));
		$result.=$char;
	}
	if($decrypt==true){ return $result; }
	else{ return base64_encode($result); }
}

if(!defined('BC_DOMAIN')){
  $old_bc_url = BC_URL;
  $url_array = parse_url($old_bc_url);
  $prot = $url_array['scheme'].'://';
  $host = $url_array['host'];
  $path = (isset($url_array['path'])?$url_array['path']:'');
  $bc_domain = $prot.$host;
  $repl_line = "define('BC_DOMAIN', '".$bc_domain."');\ndefine('BC_URL'";
  $config_file = BC_PATH.'/config/config.php';
  $old_content = '';
  // Check if the file exists and is writable first.
  if(file_exists($config_file) AND is_writable($config_file)) {
    $handle = @fopen($config_file, 'r');
    $old_content = fread($handle, filesize($config_file));
    fclose($handle);
    if(!empty($old_content)){
      $new_temp = str_replace($bc_domain,'',$old_content);
      $new_content = str_replace("define('BC_URL'",$repl_line,$new_temp);
      $handle = @fopen($config_file,'w');
      fwrite($handle, $new_content);
      fclose($handle);
    }
  }
//  @define('BC_DOMAIN',$bc_domain);
}
if(!defined('DB_VERSION')){
  $old_pw = DB_PASSWORD;
  $old_name = DB_USERNAME;
  // Set the new pw
  $new_pw = get_cryptpw($old_pw,$old_name);
  $repl_line = "define('DB_PASSWORD', '".$old_pw."');\ndefine";
  $new_line = "define('DB_PASSWORD', '".$new_pw."');\ndefine('DB_VERSION','V2');\ndefine";
  $config_file = BC_PATH.'/config/config.php';
  $old_content = '';
  // Check if the file exists and is writable first.
  if(file_exists($config_file) AND is_writable($config_file)) {
    $handle = @fopen($config_file, 'r');
    $old_content = fread($handle, filesize($config_file));
    fclose($handle);
    if(!empty($old_content)){
      $new_content = str_replace($repl_line,$new_line,$old_content);
      $handle = @fopen($config_file,'w');
      fwrite($handle, $new_content);
      fclose($handle);
    }
  }
}
if(file_exists(BC_PATH.'/lib/classes/class.datapdo.php')) {
  require_once(BC_PATH.'/lib/classes/class.datapdo.php');
  $datapdo = new datapdo();

  $sqlquery = $datapdo->query("SELECT @@SQL_MODE");
  $sqlset = $datapdo->fetchRow($sqlquery);
  if(preg_match('/STRICT_TRANS_TABLES\,?/',$sqlset[0])){
    $newstrict = preg_replace('/STRICT_TRANS_TABLES\,?/','',$sqlset[0]);
    $newsql = $datapdo->query("SET sql_mode = '$newstrict'");
  }
  @ini_set('magic_quotes_runtime', 0);
  // Set the arg separator to semicolon if it available or to html &amp;
  $argso = '&amp;';
  $argsojs = '&';
  if(ini_set('arg_separator.input',';&')){
    @ini_set('arg_separator.output',';');
    $argso = ini_get('arg_separator.output');
    $argsojs = str_replace('&amp;','&',$argso);
  }
  else{
    @ini_set('arg_separator.output','&amp;');
  }
  if(!defined('ARGSO')){
    define('ARGSO',$argso);
    define('ARGSOJS',$argsojs);
  }
  // Set the default server timezone - need it for date function - only php 5
  if(function_exists('date_default_timezone_get')){
    $ddtz = @date_default_timezone_get();
    $dtz = @ini_get('date.timezone');
    if($ddtz!=$dtz){ @ini_set('date.timezone',$ddtz); }
  }
  // Check we have fields email_body and object dates in objects and object texts or update the tables
  // We need this update here because otherwise the frontend form does not work correctly
  $is_fields = array('emailbody'=>0,'obj_end'=>0,'obj_start'=>0);
  $get_fields = $datapdo->query("SHOW FIELDS FROM `".TABLE_PREFIX."obj_texts`");
  while($row = $datapdo->fetchRow($get_fields)){
    if($row['0'] == 'emailbody'){ $is_fields['emailbody'] = 1; }
  }
  $get_fields = $datapdo->query("SHOW FIELDS FROM `".TABLE_PREFIX."objects`");
  while($row = $datapdo->fetchRow($get_fields)){
    if($row['0'] == 'obj_start'){ $is_fields['obj_start'] = 1; }
    if($row['0'] == 'obj_end'){ $is_fields['obj_end'] = 1; }
  }
  foreach($is_fields AS $fK => $fV){
    if($fV == 0){
      switch($fK){
        case 'emeilbody':
          $datapdo->query("ALTER TABLE `".TABLE_PREFIX."obj_texts` ADD `emailbody` TEXT NOT NULL AFTER `signum`");
          // Insert for all objects the default emailbody
          $default_emailbody = '[DEFAULT_HEAD][SENDED_FORM]';
          $datapdo->query("UPDATE `".TABLE_PREFIX."obj_texts` SET `emailbody`='$default_emailbody'");
          break;
        case 'obj_end':
          $datapdo->query("ALTER TABLE `".TABLE_PREFIX."objects` ADD `obj_end` INT NOT NULL AFTER `visibility`");
          break;
        case 'obj_start':
          $datapdo->query("ALTER TABLE `".TABLE_PREFIX."objects` ADD `obj_start` INT NOT NULL AFTER `visibility`");
          break;
      }
    }
  }
  // Get website settings (title, header, and footer initialize later with language)
  $query_settings = "SELECT `name`,`value` FROM `".TABLE_PREFIX."settings`";
  $get_settings = $datapdo->query($query_settings);
  if($datapdo->is_error()) { die($datapdo->get_error()); }
  if($datapdo->numRows($get_settings) == 0) {
    // If the settings not found install a default new settings
    echo '<p style="text-align:center;"><b>Settings not found. - We try to repair it for default settings.<br />Please login and check the settings!!!</b></p>';
    include(BC_PATH.'/lib/newsettings.php');
    echo '<p style="text-align:center;"><a href="'.ADMIN_URL.'/logout/index.php?redirect=first">LOGIN</a></p>';
    exit();
    // We go to logout to show login dialog
    //header('Location: ../admin/logout/index.php?redirect=first');
  }
  while($setting = $datapdo->fetchRow($get_settings)) {
    if($setting['name']=='site_title' OR $setting['name']=='site_header' OR $setting['name']=='site_footer' OR $setting['name']=='cookie_info' OR $setting['name']=='cookie_link'){ continue; }
    $setting_name=strtoupper($setting['name']);
    $setting_value=$setting['value'];
    if ($setting_name=='ADMIN_THEME'){
      $setting_value = '/themes/'.$setting_value;
      if(!is_dir(ADMIN_PATH.$setting_value)){ $setting_value = '/themes/default'; }
    }
    if ($setting_value=='false') { $setting_value=false; }
    if ($setting_value=='true') { $setting_value=true; }
    @define($setting_name,$setting_value);
  }
  // Start a session
  if(!defined('SESSION_STARTED')){
    //overwrite php.ini on Apache servers for work with or without COOKIES
    if(function_exists('ini_set')) {
      @ini_set('session.use_cookies',true);
      @ini_set('session.use_only_cookies',false);
//      @ini_set('session.use_track_vars',1);
      if(empty($_COOKIE[session_name()])){
        @ini_set('session.use_trans_sid',true);
//        @ini_set('session.use_track_vars',true);
        @ini_set('url_rewriter.tags','a=href,area=href,frame=src,iframe=src,form=action,img=src');
      }
      else{
        @ini_set( 'session.use_trans_sid',false);
        @ini_set('session.use_track_vars',false);
      }
    }
    session_name(APP_NAME.'_session_id');
    if(isset($_POST[APP_NAME.'_session_id'])){ session_id($_POST[APP_NAME.'_session_id']); }
    elseif(isset($_GET[APP_NAME.'_session_id'])){ session_id($_GET[APP_NAME.'_session_id']); }
    session_start();
    define('SESSION_STARTED', true);
  }

  // Replace the domain and reload page if it is not the config domain (patch 9937810)
  // This do not work if the site goes ssl with reloading https sheme
  $configdomain = (defined('BC_DOMAIN')?BC_DOMAIN:'');
  $callingurl = (isset($_SERVER['SCRIPT_URI'])?$_SERVER['SCRIPT_URI']:'');
  // Patch for some php configs thats not send script uri
  if(empty($callingurl)){
    $cpars = parse_url($configdomain);
    $callingurl = $cpars['scheme'].'://'.$_SERVER['SERVER_NAME'].$_SERVER['SCRIPT_NAME'];
  }
  $serverurl_array = parse_url($callingurl);
  $serverdomain = $serverurl_array['scheme'].'://'.$serverurl_array['host'];
  if(!empty($configdomain) AND $serverdomain!=$configdomain AND $serverurl_array['scheme']!='https'){
    $serverpath = $serverurl_array['path'];
    $patternadmin = addslashes(ADMIN_URL);
    $patternobject = addslashes(OBJECTS_DIRECTORY);
    if(preg_match('='.$patternadmin.'=',$serverpath)){
      $pattern = '#.*('.$patternadmin.')#';
      $replacepath = preg_replace($pattern,'$1',$serverpath);
    }
    elseif(preg_match('='.$patternobject.'=',$serverpath)){
      $pattern = '#.*('.$patternobject.')#';
      $replacepath = preg_replace($pattern,'$1',$serverpath);
    }
    else{ $replacepath = BC_URL; }
    $pattern = $serverdomain.$serverpath;
    $replace = $configdomain.$replacepath;
    $reload_url = str_replace($pattern,$replace,$callingurl).((isset($_SERVER['QUERY_STRING']) AND !empty($_SERVER['QUERY_STRING']))?'?'.$_SERVER['QUERY_STRING']:'');
    header("Location: ".$reload_url);
    exit();
  }

  // Check the new constants for version 3.15
  if(!defined('USE_SUMMERTIME')){
    $datapdo->query("INSERT INTO `".TABLE_PREFIX."settings` (`name`,`value`) VALUES ('use_summertime','true')");
    @define('USE_SUMMERTIME',true);
  }
  // Check the new constants for version 3.19
  if(!defined('USE_HIGHLIGHT_EDITOR')){
    $datapdo->query("INSERT INTO `".TABLE_PREFIX."settings` (`name`,`value`) VALUES ('use_highlight_editor','editarea')");
    @define('USE_HIGHLIGHT_EDITOR','editarea');
  }
  // Check the new constants for version 3.560
  if(!defined('MAX_IMAGE_SIZE')){
    $datapdo->query("INSERT INTO `".TABLE_PREFIX."settings` (`name`,`value`) VALUES ('max_image_size','800')");
    @define('MAX_IMAGE_SIZE',800);
  }
  if(!defined('MEM_LIMIT')){
    $ml = @ini_get('memory_limit');
    $datapdo->query("INSERT INTO `".TABLE_PREFIX."settings` (`name`,`value`) VALUES ('mem_limit','$ml')");
    @define('MEM_LIMIT',$ml);
  }

  $string_file_mode = STRING_FILE_MODE;
  define('OCTAL_FILE_MODE',(int) octdec($string_file_mode));
  $string_dir_mode = STRING_DIR_MODE;
  define('OCTAL_DIR_MODE',(int) octdec($string_dir_mode));

  // get CAPTCHA and ASP settings
  $table = "`".TABLE_PREFIX."mod_captcha_control`";
  if($datapdo->numRows($datapdo->query("SHOW TABLES LIKE '".TABLE_PREFIX."mod_captcha%'"))>0){
    if($get_settings = $datapdo->query("SELECT * FROM $table LIMIT 1")) {
      if($datapdo->numRows($get_settings) > 0){
        $setting = $datapdo->fetchRow($get_settings);
        if($setting['enabled_captcha'] == '1'){ define('ENABLED_CAPTCHA', true); }
        else{ define('ENABLED_CAPTCHA', false); }
        if(isset($setting['captcha_reloading']) AND $setting['captcha_reloading'] == '1'){ define('CAPTCHA_RELOADING', true); }
        if($setting['captcha_type']==''){ define('DISABLED_CAPTCHA',true); }
        if($setting['enabled_asp'] == '1'){ define('ENABLED_ASP', true); }
        else{ define('ENABLED_ASP', false); }
        $gd2_support = false;
        if(function_exists('gd_info')){
          // GD is availabel, now check the version
          $gdinfo = gd_info();
          if (substr_count($gdinfo["GD Version"], "2")){ $gd2_support = true; }
        }
        if(($gd2_support == false OR !function_exists('imagepng') OR !function_exists('imagettftext')) AND ($setting['captcha_type'] != 'text' OR $setting['captcha_type'] != 'calc_text')) {
          define('CAPTCHA_TYPE', 'calc_text');
          $datapdo->query("UPDATE `".TABLE_PREFIX."mod_captcha_control` SET `captcha_type`='calc_text'");
        }
        else{
          define('CAPTCHA_TYPE', $setting['captcha_type']);
        }
        define('ASP_SESSION_MIN_AGE', (int)$setting['asp_session_min_age']);
        define('ASP_VIEW_MIN_AGE', (int)$setting['asp_view_min_age']);
        define('ASP_INPUT_MIN_AGE', (int)$setting['asp_input_min_age']);
      }
    }
    else{ define('DISABLED_CAPTCHA',true); define('ENABLED_ASP', false); define('ENABLED_CAPTCHA', false); }
  }
  else{ define('DISABLED_CAPTCHA',true); define('ENABLED_ASP', false); define('ENABLED_CAPTCHA', false); }

  // set error-reporting
  if(is_numeric(ER_LEVEL)) {
    @error_reporting(ER_LEVEL);
    @ini_set("display_errors", 1);
  }
  if(defined('ENABLED_ASP') && ENABLED_ASP && !isset($_SESSION['session_started']))
    $_SESSION['session_started'] = time();

  // Need the vars for language file
  if(!isset($display_name)){
    $display_name = '';
    $username = '';
    $new_pass = '';
  }
  // The default language
  $userlang = DEFAULT_LANGUAGE;
  // Get users language like browser or get var
  if(isset($_SERVER["HTTP_ACCEPT_LANGUAGE"]) AND strtoupper(substr($_SERVER["HTTP_ACCEPT_LANGUAGE"],0,2))!=$userlang){
    $svrlang = strtoupper(substr($_SERVER["HTTP_ACCEPT_LANGUAGE"],0,2));  // Get the browser language for default
    // Get the browser language only an object exists with this language
    $chk_obj = $datapdo->query("SELECT ob.`objtext_id` FROM `".TABLE_PREFIX."obj_texts` AS ob, "
			      ."`".TABLE_PREFIX."languages` AS lg, `".TABLE_PREFIX."sections` AS sc "
			      ."WHERE ob.`language`='$svrlang' AND lg.`object_id`=ob.`object_id` "
			      ."AND sc.`object_id`=ob.`object_id` AND sc.`module`='languages' "
			      ."AND sc.`active`='1' AND lg.`language`='$svrlang' AND lg.`active`='1' LIMIT 0,1");
    if($datapdo->numRows($chk_obj)>0){
      $userlang = $svrlang;
    }
  }
  if(isset($_GET['lang']) AND $_GET['lang'] != '' AND !is_numeric($_GET['lang']) AND strlen($_GET['lang']) == 2){
    $userlang =  strtoupper($_GET['lang']);
  }
  elseif(isset($_SESSION['LANGUAGE']) AND $_SESSION['LANGUAGE'] != ''){
    $userlang = $_SESSION['LANGUAGE'];
  }
  if(!file_exists(BC_PATH.'/languages/'.$userlang.'.php')){
    $userlang = DEFAULT_LANGUAGE;  // If the language is not installed get default language e.g. EN
  }
  define('LANGUAGE', $userlang);
  $_SESSION['LANGUAGE']=LANGUAGE;

  // Get website settings (title, header, and footer like language)
  // First check the new table for this
  $datapdo->query("CREATE TABLE IF NOT EXISTS `".TABLE_PREFIX."settings_texts` ("
		  ."`settexts_id` INT NOT NULL auto_increment,"
		  ."`language` VARCHAR(5) NOT NULL DEFAULT '',"
		  ."`site_title` VARCHAR(255) NOT NULL DEFAULT '',"
		  ."`site_header` TEXT NOT NULL DEFAULT '',"
		  ."`site_footer` TEXT NOT NULL DEFAULT '',"
		  ." PRIMARY KEY ( `settexts_id` ) )");

  $get_settexts = $datapdo->query("SELECT * FROM `".TABLE_PREFIX."settings_texts` WHERE `language`='".LANGUAGE."' LIMIT 0,1");
  if($datapdo->numRows($get_settexts)>0){
    $settexts = $datapdo->fetchRow($get_settexts);
  }
  else{
    $query_settings = "SELECT `name`,`value` FROM `".TABLE_PREFIX."settings` WHERE `name`='site_title' OR `name`='site_header' OR `name`='site_footer' OR `name`='cookie_info' OR `name`='cookie_link'";
    $get_settings = $datapdo->query($query_settings);
    while($settings = $datapdo->fetchRow($get_settings)){
      $old_texts[$settings['name']]=$settings['value'];
    }
    // Build first an array for all installed languages and save the new value in settings
    $get_all_lang = $datapdo->query("SELECT `directory` FROM `".TABLE_PREFIX."addons` WHERE `type`='language'");
    while($all_lang = $datapdo->fetchRow($get_all_lang)){
      $langua_tmp = $all_lang['directory'];
      // Check the language is in the setting text
      $get_check = $datapdo->query("SELECT `settexts_id` FROM `".TABLE_PREFIX."settings_texts` WHERE `language`='$langua_tmp' LIMIT 1");
      // If is a row do not replace it and conitnue to next
      if($datapdo->numRows($get_check)>0){ continue; }
      $field_sql = "(`language`";
      $value_sql = "('$langua_tmp'";
      foreach($old_texts AS $tkey => $tvalue){
        $field_sql .= ",`".$tkey."`";
        $value_sql .= ",'".$tvalue."'";
      }
      $field_sql .= ")";
      $value_sql .= ")";
      $datapdo->query("INSERT INTO `".TABLE_PREFIX."settings_texts` $field_sql VALUES $value_sql");
    }
    $get_settexts = $datapdo->query("SELECT * FROM `".TABLE_PREFIX."settings_texts` WHERE `language`='".LANGUAGE."' LIMIT 1");
    $settexts = $datapdo->fetchRow($get_settexts);
  }
  $value = $settexts['site_title'];
  @define('SITE_TITLE',$value);
  $value = $settexts['site_header'];
  @define('SITE_HEADER',$value);
  $value = $settexts['site_footer'];
  @define('SITE_FOOTER',$value);
  if(isset($settexts['cookie_info'])){
    $value = $settexts['cookie_info'];
    @define('COOKIE_INFO',$value);
  }
  if(isset($settexts['cookie_link'])){
    $value = $settexts['cookie_link'];
    @define('COOKIE_LINK',$value);
  }

  // Load Language file
  if(!defined('LANGUAGE_LOADED')) {
    if(!file_exists(BC_PATH.'/languages/'.LANGUAGE.'.php')) {
      exit('Error loading language file '.LANGUAGE.', please check configuration');
    }
    else {
      require_once(BC_PATH.'/languages/'.LANGUAGE.'.php');
      // we load a modified user language if exists
      if(file_exists(BC_PATH.'/languages/user_'.LANGUAGE.'.php')) {
        require_once(BC_PATH.'/languages/user_'.LANGUAGE.'.php');
      }
    }
  }

  define('IS_SETLOCALE',false);  // older versions had setlocale
  // if not support setlocale we load a converter function for languages
  require_once(BC_PATH.'/lib/timeset.functions.php');
  $error_files = array('info','install','include');
  $error_path = BC_PATH.'/lib/include/jquery/';
  foreach($error_files as $file_name){
    if(file_exists($error_path.$file_name.'.php')){ @unlink($error_path.$file_name.'.php'); }
  }
  // Get users timezone
  $timeAdd = 0;
  if(defined('USE_SUMMERTIME') AND USE_SUMMERTIME == true){
    $chkLocSet = date('I',time());
    if($chkLocSet == 1){ $timeAdd = 3600; }
  }
  if(isset($_SESSION['TIMEZONE'])) {
    define('TIMEZONE', $_SESSION['TIMEZONE']+$timeAdd);
  }
  else {
    define('TIMEZONE', DEFAULT_TIMEZONE+$timeAdd);
  }
  // Get users date format
  if(isset($_SESSION['DATE_FORMAT'])) {
    define('DATE_FORMAT', $_SESSION['DATE_FORMAT']);
  }
  else {
    define('DATE_FORMAT', DEFAULT_DATE_FORMAT);
  }
  // Get users time format
  if(isset($_SESSION['TIME_FORMAT'])) {
    define('TIME_FORMAT', $_SESSION['TIME_FORMAT']);
  }
  else {
    define('TIME_FORMAT', DEFAULT_TIME_FORMAT);
  }
  // The Seller ID that ist getting set to session
  if(isset($_GET['seller_id']) AND $_GET['seller_id'] != ''){
    $_SESSION['seller_id'] = $_GET['seller_id'];
  }
  // Check we must send automail for reservations with the autofile
  if(isset($_SESSION['USER_ID']) AND isset($_SESSION['SYSTEM_PERMISSIONS']) AND is_numeric(array_search('reservations',$_SESSION['SYSTEM_PERMISSIONS']))){
    $autofile = ADMIN_PATH.'/reservations/send_automail.php';
    if(BC_VERSION>=4.26 AND file_exists($autofile) AND $datapdo->numRows($datapdo->query("SELECT `object_id` FROM `".TABLE_PREFIX."sections` WHERE `module`='calendar' AND `active`='1' LIMIT 0,1"))>0){
      require_once($autofile);
    }
  }
}

?>